<template>
  <div>
    <form
      class="p-[10px] bg-background1 game-search-form"
      @submit.prevent="performGameSearch"
    >
      <el-input
        v-model="searchModel"
        type="search"
        class="w-full mr-2 flex-auto game-search-input"
        :placeholder="$t('Search All Games')"
        @input="searching"
        @blur="onUnfocusSearch"
      />
      <el-button
        :icon="Search"
        type="primary"
        native-type="submit"
        class="game-search-button"
      />
    </form>
    <div v-if="!isFilter">
      <div v-for="gamesType in gamesTypes" :key="gamesType">
        <template v-if="renderGameForDisplay[gamesType]?.length">
          <div class="block py-[5px] px-[10px] font-bold">
            <span class="border-l-[3px] border-[var(--text)] pr-[5px]"></span>
            <span>{{ $t(gamesType) }}</span>
          </div>
          <div
            id="games-row"
            class="flex overflow-y-hidden overflow-x-scroll h-[164px] bg-background1"
            @scroll="loadGame($event, gamesType)"
          >
            <div
              v-for="game in renderGameForDisplay[gamesType]"
              :key="game.GameId"
            >
              <div
                class="block w-full h-full"
                @click="handleGameClicked(game)"
              >
                <div class="p-[10px] h-full">
                  <div
                    class="h-[100px] flex justify-center w-[100px] rounded-[5px] bg-background2 relative"
                  >
                    <img
                      v-lazy="isImageVersionExist(game.GameIconUrl)"
                      class="w-full h-full object-contain rounded-[5px] align-middle max-w-full"
                    />
                    <IconFavorite
                      :gameData="game"
                      :checkIsFavourite="checkIsFavourite"
                      :redirectToLogin="redirectToLogin"
                      :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
                      :ForMobile="true"
                      :toggle-dialog="true"
                    />
                  </div>
                  <div class="text-center flex justify-center">
                    <span class="text-[12px] text-[var(--text)] game-name">{{
                      game.EnglishGameName
                    }}</span>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </template>
      </div>
      <template v-if="lenght.reduce((a, b) => a + b, 0) === 0">
        <div
          class="flex overflow-y-hidden overflow-x-scroll h-[100px] bg-background1 text-center"
        >
          <span class="w-full text-xl flex justify-center items-center">{{
            $t("no_games_please_come_back_later")
          }}</span>
        </div>
      </template>
    </div>
    <div v-else>
      <template v-if="gameCollection.length">
        <div class="block py-[5px] px-[10px] font-bold">
          <span class="border-l-[3px] border-[var(--text)] pr-[5px]"></span>
          <span v-if="!isCallProvider">{{
            $t(gameCollection[0].GameType)
          }}</span>
          <span v-else>
            {{
              $t(isFavorite ? "favorite" : gameCollection[0].GameProviderName)
            }}
          </span>
        </div>
        <div
          v-infinite-scroll="gameLoading"
          class="flex flex-wrap overflow-y-hidden overflow-x-scroll bg-background1 pb-5"
        >
          <div
            v-for="game in gameReadyToRender"
            :key="game.GameId"
            class="w-[33.33%]"
          >
            <div
              class="block w-full h-full"
              @click="handleGameClicked(game)"
            >
              <div class="p-[10px] h-full">
                <div
                  class="h-[100px] flex justify-center w-[100px] rounded-[5px] bg-background2 relative"
                >
                  <img
                    v-lazy="isImageVersionExist(game.GameIconUrl)"
                    class="w-full h-full rounded-[5px] align-middle max-w-full object-contain"
                  />
                  <IconFavorite
                    :gameData="game"
                    :checkIsFavourite="checkIsFavourite"
                    :redirectToLogin="redirectToLogin"
                    :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
                    :ForMobile="true"
                    :toggle-dialog="true"
                  />
                </div>
                <div class="text-center">
                  <span class="text-[12px] text-[var(--text)] game-name">
                    {{ game.EnglishGameName }}
                  </span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </template>
      <template v-else>
        <div
          class="flex overflow-y-hidden overflow-x-scroll h-[100px] bg-background1 text-center"
        >
          <span
            v-if="activeTab !== 'favorite'"
            class="w-full text-xl flex justify-center items-center"
          >
            {{ $t("no_games_please_come_back_later") }}
          </span>
          <span v-else class="w-full text-xl flex justify-center items-center">
            {{ $t("No game has been added to favorite.") }}
          </span>
        </div>
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, ref, watch } from "vue";
import { Search } from "@element-plus/icons-vue";
import { useRoute } from "vue-router";
import {
  handleGameEntryOpenWindow,
  useGameEntryComponent,
} from "@/composables/useTheme";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import { gameStore } from "~~/store/game";
import { IGame } from "~~/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "SBOGameEntry",
  setup() {
    const { getAssetImage, toggleLoginRegisterDialog } = commonHelper;
    const providerModel = ref<string>();
    const {
      headerTab,
      gameTypes,
      providers,
      authenticated,
      menuTabHeaders,
      searchedGame,
      handleSearchGame,
      getGameEntryFiltered,
      activeTab,
      updateSearchResult,
      gameCollection,
    } = useGameEntryComponent();
    const { setAndUnsetGameToFavourite, checkIsFavourite, redirectToLogin } =
      useAddToFavorite();
    const searchModel = ref(searchedGame.value);
    const searchModelUsedForFilter = ref("");
    // let timeout: any = null;
    const searching = (_e: any) => {
      searchedGame.value = searchModel.value;
      handleSearchGame();
      if (!_e) performGameSearch ();
    };
    const gamesTypes = computed(() =>
      headerTab.value
        ?.filter((item) => item !== "Game Type" && item !== "Provider")
        .concat(gameTypes.value)
    );
    const route = useRoute();
    const checkIsGameType = (params: string) =>
      gameTypes.value?.includes(params);
    const isGameType = computed(() =>
      checkIsGameType(String(route.params.filter))
    );
    const isFilter = computed(() => route.params.filter !== undefined);
    const isCallProvider = ref(false);
    const isFetching = ref(false);
    const request = computed(() => ({
      Type: String(route.params.filter),
      Value: String(route.params.filter),
    }));
    const callGetGames = () => {
      if (isGameType.value) {
        isCallProvider.value = false;
        request.value.Type = "GameType";
        getGameEntryFiltered(request.value);
      } else {
        isCallProvider.value = true;
        request.value.Type =
          String(route.params.filter) === "Favorite" ? "Favorite" : "provider";
        getGameEntryFiltered(request.value);
      }
    };
    if (isFilter.value) {
      callGetGames();
    }
    watch(
      () => searchModel.value,
      () => {
        if (!searchModel.value) callGetGames();
      }
    );
    const isFavorite = computed(
      () => String(route.params.filter) === "Favorite"
    );
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (gameCollection.value !== undefined) {
        for (let i = 0; i < gameCollection.value.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = gameCollection.value.slice(
            i,
            i + chunkSize
          );
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    const gameLoading = () => {
      index.value += 1;
      if (index.value < gameRender.value.length) {
        gameRenderer();
      }
    };
    const lenght = ref([]);
    const performGameSearch = () => {
      searchedGame.value = searchModel.value;
      searchModelUsedForFilter.value = searchModel.value;
      updateSearchResult();
    };
    const games = computed(() =>
      gameStore.state.games.filter(
        (item) =>
          item.ForMobile &&
          _.toLower(item.GameName).includes(searchModelUsedForFilter.value.toLocaleLowerCase())
      )
    );
    const idx = ref(0);
    const splitGamae = (gameList: any) => {
      const chunkSize = 24;
      const g = [];
      if (gameList !== undefined) {
        for (let i = 0; i < gameList.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = gameList.slice(
            i,
            i + chunkSize
          );
          g.push(chunk);
        }
      }
      return g;
    };
    const groupedGame: any = computed(() => {
      const obj: any = {};
      if (games.value !== undefined) {
        gamesTypes.value.forEach((item) => {
          // @ts-ignore
          obj[item] = games.value.filter((game) => {
            if (item === "Top Games") {
              return game.IsHotGame;
            }
            if (item === "New Games") {
              return game.IsNewGame;
            }
            return game.GameType === item;
          });
          obj[item] = splitGamae(obj[item]);
          // @ts-ignore
          lenght.value.push(obj[item].length);
        });
      }
      return obj;
    });
    const gamesForDisplay = ref<any>({});
    const isRenderMore = ref(false);
    const gametypeToRenderMore = ref("");
    let indexObject: any = {};
    const renderGameForDisplay: any = computed(() => {
      if (
        !isRenderMore.value &&
        Object.keys(gamesForDisplay.value).length === 0
      ) {
        gamesTypes.value.forEach((item) => {
          gamesForDisplay.value[item] = groupedGame.value[item][idx.value];
        });
      }
      if (
        isRenderMore.value &&
        groupedGame.value[gametypeToRenderMore.value].length >
          indexObject[gametypeToRenderMore.value]
      ) {
        groupedGame.value[gametypeToRenderMore.value][
          indexObject[gametypeToRenderMore.value]
        ].forEach((gameItem: any) => {
          gamesForDisplay.value[gametypeToRenderMore.value].push(gameItem);
        });
      }
      return gamesForDisplay.value;
    });
    watch(route, () => {
      searchedGame.value = "";
      searchModel.value = "";
      if (isFilter.value) {
        callGetGames();
      }
    });
    watch(games, () => {
      isRenderMore.value = false;
      indexObject = {};
      lenght.value = [];
      gamesForDisplay.value = {};
      gamesTypes.value.forEach((item) => {
        // @ts-ignore
        lenght.value.push(groupedGame.value[item].length);
      });
    });
    const isScrollOver = ref(true);
    const marginTopInitialGameEntry = ref(0);
    const handleGameClicked = (game: IGame) => {
      if (authenticated.value) {
        handleGameEntryOpenWindow(game, 550, 850);
      } else {
        toggleLoginRegisterDialog();
      }
    };
    const onUnfocusSearch = () => {
      const header = document.getElementById("sbo-header");
      if (header !== null) {
        header.scrollIntoView();
      }
    };
    const scrollX = ref();
    const loadGame = (event: any, gamesType: string) => {
      gametypeToRenderMore.value = gamesType;
      scrollX.value = event.target.lastElementChild.offsetLeft;
      if (scrollX.value - 390 < event.target.scrollLeft) {
        isRenderMore.value = true;
        indexObject[gamesType] = Object.keys(indexObject).includes(gamesType)
          ? indexObject[gamesType] + 1
          : 1;
      } else {
        isRenderMore.value = false;
      }
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    return {
      headerTab,
      gameTypes,
      providers,
      providerModel,
      authenticated,
      handleGameEntryOpenWindow,
      commonHelper,
      isScrollOver,
      marginTopInitialGameEntry,
      getAssetImage,
      menuTabHeaders,
      Search,
      gamesTypes,
      groupedGame,
      isFilter,
      isCallProvider,
      isFetching,
      handleGameClicked,
      onUnfocusSearch,
      lenght,
      searchedGame,
      searching,
      searchModel,
      gameReadyToRender,
      gameLoading,
      loadGame,
      renderGameForDisplay,
      gamesForDisplay,
      indexObject,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      redirectToLogin,
      checkIsFavourite,
      isFavorite,
      toggleLoginRegisterDialog,
      activeTab,
      updateSearchResult,
      gameCollection,
      performGameSearch,
    };
  },
});
</script>
<style scoped>
:deep(.el-input--default.flex-auto > input.el-input__inner) {
  width: 100%;
}
:deep(.el-icon) {
  color: #093163;
}
:deep(.el-input .el-input__inner) {
  height: 30px;
  width: 177px;
  border-radius: 8px;
  background: white;
  color: #000;
}
:deep(.el-select .el-input__inner) {
  height: 48px;
  width: 140px;
  border-radius: 8px;
}
.game_card {
  background: #1f2141;
  border: 1px solid #4d5080;
  border-radius: 8px;
}
.before__content {
  @apply before:absolute before:top-0 before:px-[7px] before:py-[3px] before:rounded-tl-lg before:rounded-br-lg before:text-white  rounded-lg;
}
.before__new__content {
  @apply before:content-['NEW'] before:bg-[#31c46e];
}
.before__promo__content {
  @apply before:content-['PROMOTION'] before:bg-[#e63964];
}
.icon-custom-position {
  object-position: 50% -1px;
}
.selected-icon-custom-position {
  object-position: 50% -21px;
}
.el-select-dropdown__item.selected {
  color: var(--hint);
  border: none;
}
.bg-1 {
  background-color: rgb(5, 7, 30);
}
.bg-2 {
  background-color: rgb(31, 33, 65);
}
.border-selected {
  border-bottom: 2px solid var(--hint);
}
.selected-icon {
  display: block;
}
:deep(.el-input__inner) {
  background-color: rgb(31, 33, 65);
  font-size: 14px;
  width: 100% !important;
}
:deep(.el-input__wrapper) {
  width: 100%;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
:deep(.el-select .el-input__inner) {
  color: white;
}
</style>
<style>
.dropdown-width {
  width: 82%;
  left: 40px !important;
}
.el-popper.is-pure.is-light.el-select__popper.dropdown-width {
  border: 1px solid var(--border) !important;
}
</style>
<style>
[layout="black_flexible_mobile_1"] .el-carousel {
  z-index: 10;
}
.game-name {
  display: -webkit-box;
  max-width: 200px;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  overflow: hidden;
}
</style>
<style lang="scss" scoped>
.hideScrollbar::-webkit-scrollbar {
  display: none;
}
.game-search-input :deep(.el-input__inner) {
  padding-right: 2.75rem;
}
.game-search-input
  :deep(.el-input__inner[type="search"]::-webkit-search-cancel-button) {
  -webkit-appearance: none;
  appearance: none;
  display: none;
}
.game-search-form {
  position: relative;
}
.game-search-form :deep(.el-icon) {
  color: var(--textBtn);
}
.game-search-form .game-search-button {
  position: absolute;
  top: 34px;
  right: 10px;
  transform: translateY(-50%);
  height: 48px;
  border-radius: unset;
  border-top-right-radius: 8px;
  border-bottom-right-radius: 8px;
}
</style>
